proc import datafile="R:\teaching\short course\missing data\session6\simulation study\dat.csv" 
out=indat dbms=csv replace; 
getnames=yes; 
run;

proc contents data=indat;
run;

data indat2;
set indat;
if r1=1 then y1_m=y1;
else y1_m=.;
if r2=1 then y2_m=y2;
else y2_m=.;
if r3=1 then y3_m=y3;
else y3_m=.;
run;

/*Check missing data pattern*/
proc mi nimpute=0 data=indat2;
var x y1_m y2_m y3_m;
run;

/*Approach assuming no missingness*/
proc means mean maxdec=2 data=indat2;
var y1 y2 y3;
run;

proc glm data=indat2;
model y1=x;
run;

proc glm data=indat2;
model y2=x y1;
run;

proc logistic data=indat2;
class y3;
model y3(event='1')=x y1 y2;
run;

/*Complete case approach*/
proc means mean maxdec=2 data=indat2;
var y1_m y2_m y3_m;
run;

proc glm data=indat2;
model y1_m=x;
run;

proc glm data=indat2;
model y2_m=x y1_m;
run;

proc logistic data=indat2;
class y3_m;
model y3_m(event='1')=x y1_m y2_m;
run;

/*Observed likelihood approach*/
 proc mi data=indat2 seed=1518971 simple nimpute=0;
      em itprint outem=outem;
      var x y1_m y2_m y3_m;
   run;

/*Imputation approach(MCMC)*/
proc mi data=indat2 seed=1518971 nimpute=6 out=out_mi1;
      mcmc chain=multiple displayinit initial=em(itprint);
      var x y1_m y2_m y3_m;
   run;

proc genmod data=out_mi1;
       model y1_m= x/covb;
       by _Imputation_;
       ods output ParameterEstimates=gmparms
                  ParmInfo=gmpinfo
                  CovB=gmcovb;
    run;

proc mianalyze parms=gmparms covb=gmcovb parminfo=gmpinfo;
      modeleffects Intercept x;
   run;

/*Imputation approach(SMICE)*/
proc mi data=indat2 seed=1518971 nimpute=6 out=out_mi2;
      class y3_m;
      fcs reg(y1_m=x);
	  fcs reg(y2_m=x y1_m);
	  fcs logistic(y3_m=x y1_m y2_m);
      var x y1_m y2_m y3_m;
   run;

proc univariate data=out_mi2 noprint;
      var y1_m y2_m y3_m;
      output out=outuni mean=y1_m y2_m y3_m
                        stderr=sy1_m sy2_m sy3_m;
      by _Imputation_;
   run;

proc mianalyze data=outuni;
      modeleffects y1_m y2_m y3_m;
      stderr sy1_m sy2_m sy3_m;
run;

proc genmod data=out_mi2;
       model y1_m= x/covb;
       by _Imputation_;
       ods output ParameterEstimates=gmparms
                  ParmInfo=gmpinfo
                  CovB=gmcovb;
    run;

proc mianalyze parms=gmparms covb=gmcovb parminfo=gmpinfo;
      modeleffects Intercept x;
   run;
